=== debian/changelog ===
ros-kinetic-visp (3.4.0-8xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Tue, 11 May 2021 07:53:06 -0000
